unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, Menus;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    StringGrid1: TStringGrid;
    MainMenu1: TMainMenu;
    open1: TMenuItem;
    About1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TRec = record
    dec:byte;
    hex:string[2];
    ch:char;
    count:int64;
    Proc:real;
  end;

  TRecs=array[0..255] of TRec;
  TIndex=array[0..255] of integer;

var
  Form1: TForm1;
    ind:TIndex;
    ar:TRecs;

implementation
uses unit2;
{$R *.dfm}

function bytetohex(b:byte):string;
const hex:array[0..15] of char=(('0'),('1'),('2'),('3'),('4'),('5'),('6'),('7'),('8'),('9'),('A'),('B'),('C'),('D'),('E'),('F'));
begin
     result:=hex[b div 16]+hex[b mod 16];
end;

procedure TForm1.Button1Click(Sender: TObject);
var mem:tmemorystream;
    c:byte;
    i:int64;
    MaxVal,TempMaxVal:int64;
    TempIndex:integer;
begin
     if self.OpenDialog1.Execute then
        begin
             fillchar(ar,sizeof(ar),0);
             mem:=tmemorystream.Create;
             mem.LoadFromFile(self.OpenDialog1.FileName);
             mem.Position:=0;
             i:=0;
             while mem.Read(c,1)>0 do
                   begin
                        ar[c].count:=ar[c].count+1;
                        i:=i+1;
                   end;
             for c:=0 to 255 do
                 begin
                      ind[c]:=-1;
                      ar[c].dec:=c;
                      ar[c].ch:=chr(c);
                      ar[c].Proc:=100*ar[c].count/i;
                      ar[c].hex:=bytetohex(c);
                 end;
             MaxVal:=9223372036854775807;
             TempIndex:=-1;
             while (TempIndex<255) do
                begin
                    TempMaxVal:=-1;
                    for c:=0 to 255 do
                        begin
                            if (ar[c].count>TempMaxVal) and (ar[c].count<MaxVal) then
                                begin
                                    TempMaxVal:=ar[c].count;
                                end;
                        end;
                    for c:=0 to 255 do
                        begin
                            if (ar[c].count=TempMaxVal) then
                                begin
                                    Inc(TempIndex);
                                    Ind[TempIndex]:=c;
                                    MaxVal:=TempMaxVal;
                                end;
                        end;
                end;
             self.StringGrid1.RowCount:=0;
             for c:=0 to 255 do
                 if ar[ind[c]].count>0 then
                 begin
                      self.StringGrid1.RowCount:=self.StringGrid1.RowCount+1;
                      self.StringGrid1.Cells[0,self.StringGrid1.RowCount-1]:=inttostr(self.StringGrid1.RowCount-1);
                      self.StringGrid1.Cells[1,self.StringGrid1.RowCount-1]:=inttostr(ar[ind[c]].dec);
                      self.StringGrid1.Cells[2,self.StringGrid1.RowCount-1]:=ar[ind[c]].hex;
                      self.StringGrid1.Cells[3,self.StringGrid1.RowCount-1]:=ar[ind[c]].ch;
                      self.StringGrid1.Cells[4,self.StringGrid1.RowCount-1]:=inttostr(ar[ind[c]].count);
                      self.StringGrid1.Cells[5,self.StringGrid1.RowCount-1]:=floattostrF(ar[ind[c]].Proc,ffFixed,10,3);
                 end;
             mem.Clear;
             mem.Destroy;
             self.StringGrid1.FixedRows:=1;
             self.StringGrid1.Cells[0,0]:='NN';
             self.StringGrid1.Cells[1,0]:='DEC';
             self.StringGrid1.Cells[2,0]:='HEX';
             self.StringGrid1.Cells[3,0]:='CHAR';
             self.StringGrid1.Cells[4,0]:='COUNT';
             self.StringGrid1.Cells[5,0]:='%';
        end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    fillchar(ar,sizeof(ar),0);
    self.StringGrid1.Cells[0,0]:='NN';
    self.StringGrid1.Cells[1,0]:='DEC';
    self.StringGrid1.Cells[2,0]:='HEX';
    self.StringGrid1.Cells[3,0]:='CHAR';
    self.StringGrid1.Cells[4,0]:='COUNT';
    self.StringGrid1.Cells[5,0]:='%';
end;

procedure TForm1.About1Click(Sender: TObject);
begin
    unit2.Form2.ShowModal;
end;

procedure TForm1.StringGrid1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var ac,arr:integer;
    c:byte;
begin
    self.StringGrid1.MouseToCell(x,y,ac,arr);
    if (arr=0) then
        begin
            if (ac>=1) and (ac<=3) then
                begin
             self.StringGrid1.RowCount:=0;
             for c:=0 to 255 do
                 if ar[c].count>0 then
                 begin
                      self.StringGrid1.RowCount:=self.StringGrid1.RowCount+1;
                      self.StringGrid1.Cells[0,self.StringGrid1.RowCount-1]:=inttostr(self.StringGrid1.RowCount-1);
                      self.StringGrid1.Cells[1,self.StringGrid1.RowCount-1]:=inttostr(ar[c].dec);
                      self.StringGrid1.Cells[2,self.StringGrid1.RowCount-1]:=ar[c].hex;
                      self.StringGrid1.Cells[3,self.StringGrid1.RowCount-1]:=ar[c].ch;
                      self.StringGrid1.Cells[4,self.StringGrid1.RowCount-1]:=inttostr(ar[c].count);
                      self.StringGrid1.Cells[5,self.StringGrid1.RowCount-1]:=floattostrF(ar[c].Proc,ffFixed,10,3);
                 end;
                end
            else if (ac>=4) and (ac<=5) then
                begin
             self.StringGrid1.RowCount:=0;
             for c:=0 to 255 do
                 if ar[ind[c]].count>0 then
                 begin
                      self.StringGrid1.RowCount:=self.StringGrid1.RowCount+1;
                      self.StringGrid1.Cells[0,self.StringGrid1.RowCount-1]:=inttostr(self.StringGrid1.RowCount-1);
                      self.StringGrid1.Cells[1,self.StringGrid1.RowCount-1]:=inttostr(ar[ind[c]].dec);
                      self.StringGrid1.Cells[2,self.StringGrid1.RowCount-1]:=ar[ind[c]].hex;
                      self.StringGrid1.Cells[3,self.StringGrid1.RowCount-1]:=ar[ind[c]].ch;
                      self.StringGrid1.Cells[4,self.StringGrid1.RowCount-1]:=inttostr(ar[ind[c]].count);
                      self.StringGrid1.Cells[5,self.StringGrid1.RowCount-1]:=floattostrF(ar[ind[c]].Proc,ffFixed,10,3);
                 end;
                end
        end;
    if self.StringGrid1.RowCount<2 then
        self.StringGrid1.RowCount:=2;
    self.StringGrid1.FixedRows:=1;
end;

end.
